#include <stdio.h>
#include <stdlib.h>
#include "stack.h"

#define MAX 100

int main(int argc, char**argv)
   {
   int i;
   int *ip;
   struct stack * s;
   
   s = stack_new(MAX);
   if (NULL == s)
      {
      perror("stack_new: ");
      exit(EXIT_FAILURE);
      }

   for (i=0; i < MAX/2; i++)
      {
       ip = malloc(sizeof(int));
      *ip = i;
      stack_push(s, (void *) ip);
      }

   printf("stack size is %zd\n", stack_size(s));
   while (NULL != (ip = stack_pop(s)))
      {
      printf("%d\n", *ip);
      }
   printf("stack size is %zd\n", stack_size(s));

   stack_delete(s);

   exit(EXIT_SUCCESS);
   }
